﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;

namespace BooksExample
{
	public partial class App : Application
	{
		public App()
		{
			this.Startup += this.Application_Startup;
			this.Exit += this.Application_Exit;
			this.UnhandledException += this.Application_UnhandledException;

			InitializeComponent();
		}

		private void Application_Startup(object sender, StartupEventArgs e)
		{
			NavigationService.UseBrowserHistory = true;
			this.RootVisual = new RadFrameContainer();
			NavigationService service = NavigationService.GetNavigationService();
			//FadeTransition transition = new FadeTransition(new TimeSpan(0,0,0,0,500));
			//service.Transition = transition;
			service.Transition = new SilverlightClassLibrary1.MyExampleTransition();
			if (!NavigationService.LoadDeepLink())
			{
				service.SetApplicationUri("BooksExample.MainPage/BooksExample.Home");
			}

			service.GetPageFromBookmark += new EventHandler<FrameInfoEventArgs>(this.Service_GetPageFromBookmark);
			service.GetBookmarkFromUri += new EventHandler<UriInfoEventArgs>(this.Service_GetBookmarkFromUri);
			service.GetUriFromBookmark += new EventHandler<UriInfoEventArgs>(this.Service_GetUriFromBookmark);
		}

		private void Service_GetUriFromBookmark(object sender, UriInfoEventArgs e)
		{
			string bookmark = e.Bookmark;
		}

		private void Service_GetBookmarkFromUri(object sender, UriInfoEventArgs e)
		{
			string uri = e.Uri;
		}

		private void Service_GetPageFromBookmark(object sender, FrameInfoEventArgs e)
		{
			if (e.FrameType.Contains("Book_"))
			{
				BookDescription page = new BookDescription();
				string frameType = e.FrameType.Substring(0, e.FrameType.Length - 1);
				page.BookID = frameType.Substring(frameType.LastIndexOf("_") + 1);
				e.Frame = page;
			}
			if (e.FrameType.Contains("Autor_"))
			{
				AutorDescription page = new AutorDescription();
				string frameType = e.FrameType.Substring(0, e.FrameType.Length - 1);
				page.AutorID = frameType.Substring(frameType.LastIndexOf("_") + 1);
				e.Frame = page;
			}
		}

		private void Application_Exit(object sender, EventArgs e)
		{
		}

		private void Application_UnhandledException(object sender, ApplicationUnhandledExceptionEventArgs e)
		{
			// If the app is running outside of the debugger then report the exception using
			// the browser's exception mechanism. On IE this will display it a yellow alert 
			// icon in the status bar and Firefox will display a script error.
			if (!System.Diagnostics.Debugger.IsAttached)
			{
				// NOTE: This will allow the application to continue running after an exception has been thrown
				// but not handled. 
				// For production applications this error handling should be replaced with something that will 
				// report the error to the website and stop the application.
				e.Handled = true;
				Deployment.Current.Dispatcher.BeginInvoke(delegate { this.ReportErrorToDOM(e); });
			}
		}
		private void ReportErrorToDOM(ApplicationUnhandledExceptionEventArgs e)
		{
			try
			{
				string errorMsg = e.ExceptionObject.Message + e.ExceptionObject.StackTrace;
				errorMsg = errorMsg.Replace('"', '\'').Replace("\r\n", @"\n");

				System.Windows.Browser.HtmlPage.Window.Eval("throw new Error(\"Unhandled Error in Silverlight 2 Application " + errorMsg + "\");");
			}
			catch (Exception)
			{
			}
		}

	}
}
