﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Xml.Linq;
using Telerik.Windows.Controls;

namespace BooksExample
{
	public static class Data
	{
		public static List<Item> GetBooks()
		{
			XDocument booksList = XDocument.Load("Data/Books.xml");
			List<Item> books = (from bookItem in booksList.Descendants("bookItem")
								select new Item()
								{
									Id = int.Parse(bookItem.Attribute("id").Value),
									Name = bookItem.Attribute("name").Value,
									Description = bookItem.Attribute("description").Value,
									Image = bookItem.Attribute("image").Value
								}).ToList();
			return books;
		}

		public static Item GetBookByID(string bookID)
		{
			List<Item> booksList = GetBooks();
			
			foreach (Item book in booksList)
			{
				if (book.Id.ToString() == bookID)
				{
					return book;
				}
			}
			return null;
		}

		public static List<Item> GetAutors()
		{
			XDocument autorsList = XDocument.Load("Data/Autors.xml");
			List<Item> autors = (from bookItem in autorsList.Descendants("autorItem")
								select new Item()
								{
									Id = int.Parse(bookItem.Attribute("id").Value),
									Name = bookItem.Attribute("name").Value,
									Description = bookItem.Attribute("description").Value,
								}).ToList();
			return autors;
		}

		public static Item GetAutorByID(string autorID)
		{
			List<Item> autorsList = GetAutors();

			foreach (Item autor in autorsList)
			{
				if (autor.Id.ToString() == autorID)
				{
					return autor;
				}
			}
			return null;
		}
	}
}
